org.apache.struts2.jasper.xmlparser

## Class XMLEncodingDetector

- java.lang.Object
- - org.apache.struts2.jasper.xmlparser.XMLEncodingDetector

-     public class XMLEncodingDetector
      extends Object

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static int` | `DEFAULT_BUFFER_SIZE`
    `static int` | `DEFAULT_XMLDECL_BUFFER_SIZE`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `XMLEncodingDetector()` Constructor

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `static Object[]` | `getEncoding(String fname, JarFile jarFile, JspCompilationContext ctxt, ErrorDispatcher err)` Autodetects the encoding of the XML document supplied by the given input stream.
    `boolean` | `isExternal()`
    `int` | `peekChar()`
    `int` | `scanChar()`
    `boolean` | `scanData(String delimiter, XMLStringBuffer buffer)` Scans a range of character data up to the specified delimiter, setting the fields of the XMLString structure, appropriately.
    `int` | `scanLiteral(int quote, XMLString content)` Scans a range of attribute value data, setting the fields of the XMLString structure, appropriately.
    `String` | `scanName()`
    `String` | `scanPseudoAttribute(boolean scanningTextDecl, XMLString value)` Scans a pseudo attribute.
    `boolean` | `skipChar(int c)` Skips a character appearing immediately on the input.
    `boolean` | `skipSpaces()` Skips space characters appearing immediately on the input.
    `boolean` | `skipString(String s)` Skips the specified string appearing immediately on the input.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### DEFAULT_BUFFER_SIZE

          public static final int DEFAULT_BUFFER_SIZE

      See Also:
        Constant Field Values

    - #### DEFAULT_XMLDECL_BUFFER_SIZE

          public static final int DEFAULT_XMLDECL_BUFFER_SIZE

      See Also:
        Constant Field Values

  - ### Constructor Detail

    - #### XMLEncodingDetector

          public XMLEncodingDetector()

      Constructor

  - ### Method Detail

    - #### getEncoding

          public static Object[] getEncoding(String fname,
                                             JarFile jarFile,
                                             JspCompilationContext ctxt,
                                             ErrorDispatcher err)
                                      throws IOException,
                                             JasperException

      Autodetects the encoding of the XML document supplied by the given input stream.

      Encoding autodetection is done according to the XML 1.0 specification, Appendix F.1: Detection Without External Encoding Information.

      Parameters:
        `fname` - file name
        `jarFile` - jar file
        `ctxt` - compilation context
        `err` - error dispatcher
      Returns:
        Two-element array, where the first element (of type java.lang.String) contains the name of the (auto)detected encoding, and the second element (of type java.lang.Boolean) specifies whether the encoding was specified using the 'encoding' attribute of an XML prolog (TRUE) or autodetected (FALSE).
      Throws:
        `IOException` - in case of IO errors
        `JasperException` - in case of Jasper errors

    - #### isExternal

          public boolean isExternal()

      Returns:
        true if the current entity being scanned is external.

    - #### peekChar

          public int peekChar()
                       throws IOException

      Returns:
        the next character on the input.

        Note: The character is not consumed.

      Throws:
        `IOException` - Thrown if i/o error occurs.

    - #### scanChar

          public int scanChar()
                       throws IOException

      Returns:
        the next character on the input.

        Note: The character is consumed.

      Throws:
        `IOException` - Thrown if i/o error occurs.

    - #### scanName

          public String scanName()
                          throws IOException

      Returns:
        a string matching the Name production appearing immediately on the input as a symbol, or null if no Name string is present.

        Note: The Name characters are consumed.

        Note: The string returned must be a symbol. The SymbolTable can be used for this purpose.

      Throws:
        `IOException` - Thrown if i/o error occurs.
      See Also:
        `SymbolTable`, `XMLChar.isName(int)`, `XMLChar.isNameStart(int)`

    - #### scanLiteral

          public int scanLiteral(int quote,
                                 XMLString content)
                          throws IOException

      Scans a range of attribute value data, setting the fields of the XMLString structure, appropriately.

      Note: The characters are consumed.

      Note: This method does not guarantee to return the longest run of attribute value data. This method may return before the quote character due to reaching the end of the input buffer or any other reason.

      Note: The fields contained in the XMLString structure are not guaranteed to remain valid upon subsequent calls to the entity scanner. Therefore, the caller is responsible for immediately using the returned character data or making a copy of the character data.

      Parameters:
        `quote` - The quote character that signifies the end of the attribute value data.
        `content` - The content structure to fill.
      Returns:
        Returns the next character on the input, if known. This value may be -1 but this does note designate end of file.
      Throws:
        `IOException` - Thrown if i/o error occurs.

    - #### scanData

          public boolean scanData(String delimiter,
                                  XMLStringBuffer buffer)
                           throws IOException

      Scans a range of character data up to the specified delimiter, setting the fields of the XMLString structure, appropriately.

      Note: The characters are consumed.

      Note: This assumes that the internal buffer is at least the same size, or bigger, than the length of the delimiter and that the delimiter contains at least one character.

      Note: This method does not guarantee to return the longest run of character data. This method may return before the delimiter due to reaching the end of the input buffer or any other reason.

      Note: The fields contained in the XMLString structure are not guaranteed to remain valid upon subsequent calls to the entity scanner. Therefore, the caller is responsible for immediately using the returned character data or making a copy of the character data.

      Parameters:
        `delimiter` - The string that signifies the end of the character data to be scanned.
        `buffer` - The data structure to fill.
      Returns:
        Returns true if there is more data to scan, false otherwise.
      Throws:
        `IOException` - Thrown if i/o error occurs.

    - #### skipChar

          public boolean skipChar(int c)
                           throws IOException

      Skips a character appearing immediately on the input.

      Note: The character is consumed only if it matches the specified character.

      Parameters:
        `c` - The character to skip.
      Returns:
        Returns true if the character was skipped.
      Throws:
        `IOException` - Thrown if i/o error occurs.

    - #### skipSpaces

          public boolean skipSpaces()
                             throws IOException

      Skips space characters appearing immediately on the input.

      Note: The characters are consumed only if they are space characters.

      Returns:
        Returns true if at least one space character was skipped.
      Throws:
        `IOException` - Thrown if i/o error occurs.
        `EOFException` - Thrown on end of file.
      See Also:
        `XMLChar.isSpace(int)`

    - #### skipString

          public boolean skipString(String s)
                             throws IOException

      Skips the specified string appearing immediately on the input.

      Note: The characters are consumed only if they are space characters.

      Parameters:
        `s` - The string to skip.
      Returns:
        Returns true if the string was skipped.
      Throws:
        `IOException` - Thrown if i/o error occurs.

    - #### scanPseudoAttribute

          public String scanPseudoAttribute(boolean scanningTextDecl,
                                            XMLString value)
                                     throws IOException,
                                            JasperException

      Scans a pseudo attribute.
      Parameters:
        `scanningTextDecl` - True if scanning this pseudo-attribute for a TextDecl; false if scanning XMLDecl. This flag is needed to report the correct type of error.
        `value` - The string to fill in with the attribute value.
      Returns:
        The name of the attribute

        Note: This method uses fStringBuffer2, anything in it at the time of calling is lost.

      Throws:
        `IOException` - in case of IO errors
        `JasperException` - in case of Jasper errors

Copyright © 2000–2024 Apache Software Foundation. All rights reserved.